include('helpers\\window_xxx.js');
include('helpers\\menu_xxx.js');

// Set default properties (used on data later)
let properties = {
	bOptions:	['Options panel opened?'		, false		], // To maintain the same window on script reload (would be an ID when having multiple windows)
	tabWidth:	['full / text'					, 'full'	], // Tatb behaviour
	UI:			['default / material'			, 'material'], // Theme
	tracksV1:	['tracksV1 property decription'	, 10		],
	tracksV2:	['tracksV2 property decription'	, 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'],
	tracksB1:	['tracksB1 property decription'	, true		],
	tracksC1:	['tracksC1 property decription'	, 0xFFEAE4D1],
	tracksV3:	['tracksV3 property decription'	, 20		],
	tracksV4:	['tracksV4 property decription'	, 30		],
	tracksB2:	['tracksB2 property decription'	, true		],
	tracksB3:	['tracksB3 property decription'	, false		],
	tracksA1:	['tracksA1 property decription'	, 'Value 2'	],
	tracksV5:	['tracksV5 property decription'	, 15		],
	tracksB4:	['tracksB4 property decription'	, true		],
};
setProperties(properties);
properties = getProperties(properties);
const folders = {};
folders.data = fb.ProfilePath + 'js_data\\';
_createFolder(folders.data);

// Set options window
const options = new _window({width: window.Width, height: window.Height, tabWidth: properties.tabWidth[1], UI: properties.UI[1], properties, bFitData: true, bAutoSave: false});
// Set save and load methods to call them easily later (they would be used too if setting autosave to true)
options.save = () => {
	overwriteProperties(options.properties); 
	utils.WriteTextFile(folders.data + 'options_data.json', JSON.stringify(options.getTabData('Config'), null, '\t'), true);
}
options.load = () => {
	options.properties = getProperties(options.properties);
	// Only config tab is saved as json
	if (utils.IsFile(folders.data + 'options_data.json')) {
		const text = utils.ReadTextFile(folders.data + 'options_data.json', 65001)
		if (text && text.length) {
			const data = JSON.parse(text);
			if (data) {options.configTab('Config', {data});}
		}
	}
}

// Add 4 tabs with its data
options.addTab({title: 'Tracks', columns: 4, data: [
	[
		{title: 'Title 1', subTitle: 'Subtitle 1', values: [{name: 'Value with long description:', pId: 'tracksV1', pIdx: 1}, {name: 'Another value:', pId: 'tracksV2', pIdx: 1}]},
		{subTitle: 'Subtitle 2', values: [{name: 'This is a value check:', pId: 'tracksB1', pIdx: 1}]},
		{values: [{name: 'Choose color:', pId: 'tracksC1', pIdx: 1, mode: 'colorPicker'}]}
	],
	[
		{title: 'Title 2', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', pId: 'tracksV3', pIdx: 1}, {name: 'Another value:', pId: 'tracksV4', pIdx: 1}]},
		{title: 'Title 3', subTitle: 'Subtitle 2', values: [{name: 'Value check group option 1:', pId: 'tracksB2', pIdx: 1, mode: 'checkGroup'}, {name: 'Value check group option 2:', pId: 'tracksB3', pIdx: 1, mode: 'checkGroup'}]}
	],
	[
		// Empty column
	],
	[
		{title: 'Title 4', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', pId: 'tracksA1', pIdx: 1, list: ['Value 1', 'Value 2', 'Value 3']}, {name: 'This is a value:', pId: 'tracksV5', pIdx: 1}, {name: 'This is a toggle control:', pId: 'tracksB4', pIdx: 1, mode: 'toggleControl'}]}
	]
], description: 'This tab modifies data saved on properties panel'});
// The other tabs have data added without pointing to a property, thus saving it -permanently- requires extra steps
options.addTab({title: 'Playlists', columns: 3, data: [
	[
		{title: 'Title 1', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', value: 10}, {name: 'Another value:', value: 20}]},
		{title: 'Title 2', subTitle: 'Subtitle 2', values: [{name: 'This is a value check 1:', value: true}]}
	],
	[
		{title: 'Title 3', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', value: 20}, {name: 'Another value:', value: 30}]},
		{title: 'Title 4', subTitle: 'Subtitle 2', values: [{name: 'This is a value check 2:', value: false}]}
	],
	[
		{title: 'Title 5', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', value: 20}, {name: 'Another value:', value: 30}]},
		{title: 'Title 6', subTitle: 'Subtitle 2', values: [{name: 'This is a value check 3:', value: false}, {name: 'This is a value check 4:', value: false}]}
	]
], description: 'Data here is only saved internally within options window (lost on reload)'});

options.addTab({title: 'Config', columns: 2, data: [
	[
		{title: 'Title 1', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', value: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'}, {name: 'Another value:', value: 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'}]},
		{title: 'Title 2', subTitle: 'Subtitle 2', values: [{name: 'This is a value check 1:', value: true}]}
	] // 2nd empty column is automatically created
], description: 'Data here is saved internally within options window and then on json'});

options.addTab({title: 'Other', columns: 2, description: 'An empty tab...'});

// Windows may be embedded too within a tab
// Save/load methods would be needed to be set here too
const optionsTwo = new _window({y: options.tabsHeight(), width: window.Width, height: window.Height - options.tabsHeight(), tabWidth: properties.tabWidth[1], UI: properties.UI[1], properties, bFitData: true, bAutoSave: false});
optionsTwo.addTab({title: 'Embedded  A', columns: 3, data: [
	[
		{title: 'Title 1', subTitle: 'Subtitle 1', values: [{name: 'This is a value:', value: 10}, {name: 'Another value:', value: 20}]},
		{title: 'Title 2', subTitle: 'Subtitle 2', values: [{name: 'This is a value check 1:', value: true}]}
	]
], description: 'An empty tab...'});
optionsTwo.addTab({title: 'Embedded B', columns: 3, description: 'An empty tab...'});
options.addTab({title: 'Embedded', object: optionsTwo, description: 'An empty tab...'});

// Add a menu to swap windows
// Since auto-save is disabled, data saving is done when returning to the main window. Only exception to this rule is saving at script unload
// Using .loadAll() or .saveAll() instead of .load() / .save() will also apply for any embedded object
var menu = new _menu();
menu.newEntry({entryText: 'Show Options', func: () => {options.loadAll(); options.properties.bOptions[1] = true; options.saveAll(); window.Repaint(true);}});
menu.newEntry({entryText: 'Show Main', func: () => {options.properties.bOptions[1] = false; options.saveAll(); window.Repaint(true);}});

// Callbacks
function on_paint(gr) {
	if (options.properties.bOptions[1]) {options.paint(gr);}
	else {
		gr.GdiDrawText('SHIFT + R. CLICK TO OPEN MENU \nAND SWITCH BETWEEN WINDOWS\n\nChange tab behavior and theme on properties.\n(SHIFT + WIN + R. CLICK)', _gdiFont('Segoe UI', _scale(10)), 0xFF000000 , 0, 0, window.Width, window.Height, DT_VCENTER|DT_CENTER|DT_CALCRECT|DT_NOPREFIX);
	}
}

function on_size(width, height) {
	options.resize(width, height);
}

function on_mouse_move(x, y) {
	if (options.properties.bOptions[1]) {options.move(x, y);}
	return;
}

function on_mouse_leave() {
	if (options.properties.bOptions[1]) {options.leave();}
	return;
}

function on_mouse_lbtn_up(x, y, mask) {
	if (options.properties.bOptions[1]) {options.btn_up(x, y, mask);}
}

function on_mouse_lbtn_down(x, y, mask) {
	if (options.properties.bOptions[1]) {options.btn_down(x, y, mask);}
}

function on_mouse_lbtn_dblclk(x, y, mask) {
	if (options.properties.bOptions[1]) {options.lbtn_dblclk(x, y);}
}

function on_mouse_rbtn_up(x, y, mask) {
	if (mask === MK_SHIFT) {return menu.btn_up(x, y);}
	else if (options.properties.bOptions[1]) {options.rbtn_down(x, y, mask);}
	return true;
}

function on_key_down(vkey) {
	if (options.properties.bOptions[1]) {options.key_down(vkey);}
}

function on_char(code) {
	if (options.properties.bOptions[1]) {options.on_char(code);}
}

function on_script_unload() {
	if (options.properties.bOptions[1]) {options.save();}
}

// Helpers

function setProperties(propertiesDescriptor, bForce = false) {
	for (let k in propertiesDescriptor){
		let description = propertiesDescriptor[k][0];
		if (bForce) { // Only use set when overwriting... this is done to have default values set first and then overwriting if needed.
			window.SetProperty(description, propertiesDescriptor[k][1]);
		} else {
			window.GetProperty(description, propertiesDescriptor[k][1]);
		}
	}
	return propertiesDescriptor;
}

function overwriteProperties(propertiesDescriptor) {
	return setProperties(propertiesDescriptor, true);
}

function getProperties(propertiesDescriptor, bOnlyValues = false) {
	let output = {};
	if (bOnlyValues) { // only outputs values, without description
		let descr = null;
		for (let k in propertiesDescriptor){
			output[k] = null;
			descr = propertiesDescriptor[k][0];
			output[k] = window.GetProperty(descr);
		}
	} else {
		for (let k in propertiesDescriptor){ // entire properties object with fixed descriptions
			output[k] = [null,null];
			output[k][0] = propertiesDescriptor[k][0];
			output[k][1] = window.GetProperty(output[k][0]);
		}
	}
	return output;
}

const fso = new ActiveXObject('Scripting.FileSystemObject');

function _createFolder(folder) {
	if (!utils.IsDirectory(folder)) {
		try {
			fso.CreateFolder(folder);
		} catch (e) {
			return false;
		}
		return utils.IsDirectory(folder);
	}
	return false;
}